#include<bits/stdc++.h>
using namespace std;
int main()
{
    ios::sync_with_stdio(false);
    int n;
    cin>>n;
    int q;
    cin>>q;
    string s;
    cin>>s;
    vector<int>v(q);
    for(int i=0;i<q;i++)
    {
        int a,b;
        cin>>a>>b;
        int pom=b-a+1;
        int pom1=pom/2;
        int pom2=pom%2;
        v[i]=((pom2+pom1)*pom1);
    }

    for(int i=0;i<q;i++)
        cout<<v[i]<<endl;
return 0;
}